unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Menus;

type
  TMainForm = class(TForm)
    Label2: TLabel;
    Label1: TLabel;
    StartBtn: TButton;
    ListBox1: TListBox;
    ListBox2: TListBox;
    LinBtn: TButton;
    LinHelpBtn: TButton;
    RipBtn: TButton;
    RipHelpBtn: TButton;
    BubBtn: TButton;
    BubHelpBtn: TButton;
    QuiBtn: TButton;
    QuiHelpBtn: TButton;
    List1Label: TLabel;
    List2Label: TLabel;
    ExitBtn: TButton;
    GroupBox1: TGroupBox;
    Label3: TLabel;
    StatLabel1: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    StatLabel2: TLabel;
    Label6: TLabel;
    StatLabel3: TLabel;
    Label7: TLabel;
    StatLabel4: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    TimeLabel1: TLabel;
    TimeLabel2: TLabel;
    TimeLabel3: TLabel;
    TimeLabel4: TLabel;
    Label10: TLabel;
    EffLabel1: TLabel;
    EffLabel2: TLabel;
    EffLabel3: TLabel;
    EffLabel4: TLabel;
    btFuzzyHlp: TButton;
    btFuzzy: TButton;
    Label11: TLabel;
    StatLabel5: TLabel;
    TimeLabel5: TLabel;
    EffLabel5: TLabel;
    procedure StartBtnClick(Sender: TObject);
    procedure LinBtnClick(Sender: TObject);
    procedure RipBtnClick(Sender: TObject);
    procedure BubBtnClick(Sender: TObject);
    procedure QuiBtnClick(Sender: TObject);
    procedure btFuzzyClick(Sender: TObject);
    procedure LinHelpBtnClick(Sender: TObject);
    procedure RipHelpBtnClick(Sender: TObject);
    procedure BubHelpBtnClick(Sender: TObject);
    procedure QuiHelpBtnClick(Sender: TObject);
    procedure btFuzzyHlpClick( Sender: TObject );
    procedure ExitBtnClick(Sender: TObject);
  private
    { Private-Deklarationen }
    Procedure DisableAll;
    Procedure EnableAll;
    Procedure SortListUpdate;
  public
    { Public-Deklarationen }
  end;

var
  MainForm: TMainForm;

implementation

uses
  LinInfo, RipInfo, BubInfo, QuiInfo, FuzzInfo;

type
  SortInt = 0..10000;
  SortList = array [ 1..High(SortInt) ] of SortInt;

var
  Unsorted: SortList;
  Sorted: SortList;
  SortNum: Word;
  TickStart, SortTime: LongInt;

{$R *.DFM}

procedure TMainForm.DisableAll;
begin
  ListBox1.Enabled := false;
  ListBox2.Enabled := false;
  StartBtn.Default := false;
  StartBtn.Enabled := false;
  LinBtn.Default := false;
  LinBtn.Enabled := false;
  LinHelpBtn.Default := false;
  LinHelpBtn.Enabled := false;
  RipBtn.Default := false;
  RipBtn.Enabled := false;
  RipHelpBtn.Default := false;
  RipHelpBtn.Enabled := false;
  BubBtn.Default := false;
  BubBtn.Enabled := false;
  BubHelpBtn.Default := false;
  BubHelpBtn.Enabled := false;
  QuiBtn.Default := false;
  QuiBtn.Enabled := false;
  QuiHelpBtn.Default := false;
  QuiHelpBtn.Enabled := false;
  btFuzzy.Default := false;
  btFuzzy.Enabled := false;
  btFuzzyHlp.Default := false;
  btFuzzyHlp.Enabled := false;
  ExitBtn.Default := false;
  ExitBtn.Enabled := false;
  MainForm.Cursor := crHourGlass;
end;

procedure TMainForm.EnableAll;
begin
  Cursor := crDefault;
  ListBox1.Enabled := true;
  ListBox2.Enabled := true;
  StartBtn.Enabled := true;
  LinBtn.Enabled := true;
  LinHelpBtn.Enabled := true;
  RipBtn.Enabled := true;
  RipHelpBtn.Enabled := true;
  BubBtn.Enabled := true;
  BubHelpBtn.Enabled := true;
  QuiBtn.Enabled := true;
  QuiHelpBtn.Enabled := true;
  btFuzzy.Enabled := true;
  btFuzzyHlp.Enabled := true;
  ExitBtn.Enabled := true;
end;

procedure SortChange( var El1, El2: SortInt );
var Save: SortInt;
begin
  Save := El1;
  El1 := El2;
  El2 := Save;
  Inc( SortNum );
end;

function RndFltRange(LeftBorder, RightBorder: LongInt): Extended;
begin
 RndFltRange := Random * ((RightBorder + 1) - LeftBorder) + LeftBorder;
end;

function RndIntRange(LeftBorder, RightBorder: LongInt): LongInt;
begin
  RndIntRange := Trunc(RndFltRange (LeftBorder, RightBorder));
end;

procedure TMainForm.StartBtnClick( Sender: TObject );
var
  i, z1, z2: SortInt;
  S, Lab: string;
begin
  DisableAll;
  ListBox1.Items.Clear;
  ListBox2.Items.Clear;
  ListBox2.Enabled := false;
  List2Label.Enabled := false;
  StatLabel1.Caption := '-';
  StatLabel2.Caption := '-';
  StatLabel3.Caption := '-';
  StatLabel4.Caption := '-';
  StatLabel5.Caption := '-';
  TimeLabel1.Caption := '-';
  TimeLabel2.Caption := '-';
  TimeLabel3.Caption := '-';
  TimeLabel4.Caption := '-';
  TimeLabel5.Caption := '-';
  EffLabel1.Caption := '-';
  EffLabel2.Caption := '-';
  EffLabel3.Caption := '-';
  EffLabel4.Caption := '-';
  EffLabel5.Caption := '-';
  with List1Label do
    begin
      Enabled := true;
      Lab := Caption;
      Caption := 'Unsortierte Liste wird erstellt...';
      Update;
    end;
  { Eindeutige Zufallszahlen erzeugen }

  for i := 1 to High( SortInt ) do Unsorted[i] := i;
  Randomize;

  for i := 1 to High( SortInt ) do
    begin
      z1 := RndIntRange( 1, High(SortInt) );
      z2 := RndIntRange( 1, High(SortInt) );
      SortChange( Unsorted[z1], Unsorted[z2] );
    end;

  for i := 1 to High( SortInt ) do
    begin
      Str( Unsorted[i]: 24, S );
      ListBox1.Items.Add( S );
    end;

  List1Label.Caption := Lab;
  List1Label.Update;
  EnableAll;
  ListBox2.Enabled := false;
  List2Label.Enabled := false;
  LinBtn.Default := true;
end;

procedure TMainForm.SortListUpdate;
var
  i: SortInt;
  S: String;
begin
  with List2Label do
    begin
      Caption:='Sortierte Liste wird erstellt...';
      Update;
    end;
 with ListBox2.Items do
   begin
     Clear;
     for i := 1 to High( SortInt ) do
       begin
         Str( Sorted[i]: 24, S );
         Add( S );
       end;
   end;
end;

procedure TMainForm.LinBtnClick( Sender: TObject );
var
  RepeatFlag: Boolean;
  i: SortInt;
begin
  DisableAll;
  with List2Label do
    begin
      Enabled := true;
      Caption := 'Liste wird mit LinearSort sortiert...';
      Update;
    end;
  StatLabel1.Caption := 'Wird sortiert';
  StatLabel1.Update;
  TimeLabel1.Caption := 'Wird sortiert';
  TimeLabel1.Update;
  EffLabel1.Caption := 'Wird sortiert';
  EffLabel1.Update;
  Sorted := Unsorted;
  SortNum := 0;
  TickStart := GetTickCount;
  { LinearSort }
  repeat
    RepeatFlag := false;
    for i:=1 to High( SortInt ) - 1 do
    if( Sorted[i] > Sorted[i + 1] ) then
      begin
        SortChange( Sorted[i], Sorted[i + 1] );
        RepeatFlag := true;
      end;
   until( not RepeatFlag );
  {}
  SortTime := GetTickCount - TickStart;
  TimeLabel1.Caption := IntToStr( SortTime );
  if( SortTime > 0 ) then
    EffLabel1.Caption := FloatToStr( SortNum / SortTime )
  else
    EffLabel1.Caption := 'Fehler';
  StatLabel1.Caption := IntToStr( SortNum );
  SortListUpdate;
  with List2Label do
    begin
      Caption := 'S&ortierte Liste (LinearSort verwendet):';
      Update;
    end;
  EnableAll;
  RipBtn.Default := true;
end;

procedure TMainForm.RipBtnClick( Sender: TObject );
var i, j: SortInt;
begin
  DisableAll;
  with List2Label do
    begin
      Enabled := true;
      Caption := 'Liste wird mit RippleSort sortiert...';
      Update;
    end;
  StatLabel2.Caption := 'Wird sortiert';
  StatLabel2.Update;
  TimeLabel2.Caption := 'Wird sortiert';
  TimeLabel2.Update;
  EffLabel2.Caption := 'Wird sortiert';
  EffLabel2.Update;
  Sorted := Unsorted;
  SortNum := 0;
  TickStart := GetTickCount;
  { RippleSort }
  for i := 1 to High( SortInt ) - 1 do
    for j := i + 1 to High( SortInt ) do
      if( Sorted[i] > Sorted[j] ) then
        SortChange( Sorted[i], Sorted[j] );
  {}
  SortTime := GetTickCount - TickStart;
  TimeLabel2.Caption := IntToStr( SortTime );
  if( SortTime > 0 ) then
    EffLabel2.Caption := FloatToStr( SortNum / SortTime )
  else
    EffLabel2.Caption := 'Fehler';
  StatLabel2.Caption := IntToStr( SortNum );
  SortListUpdate;
  with List2Label do
    begin
      Caption := 'S&ortierte Liste (RippleSort verwendet):';
      Update;
    end;
  EnableAll;
  BubBtn.Default := true;
end;

procedure TMainForm.BubBtnClick( Sender: TObject );
var i, j, m, k: SortInt;
begin
  DisableAll;
  with List2Label do
    begin
      Enabled := true;
      Caption := 'Liste wird mit BubbleSort sortiert...';
      Update;
    end;
  StatLabel3.Caption := 'Wird sortiert';
  StatLabel3.Update;
  TimeLabel3.Caption := 'Wird sortiert';
  TimeLabel3.Update;
  EffLabel3.Caption := 'Wird sortiert';
  EffLabel3.Update;
  Sorted := Unsorted;
  SortNum := 0;
  TickStart := GetTickCount;
  { BubbleSort }
  for i := 1 to High( SortInt ) - 1 do
    begin
      m := Sorted[i]; k := i;
      for j := i + 1 to High( SortInt ) do
        if( Sorted[j] < m ) then
          begin
            m := Sorted[j];
            k := j;
          end;
        SortChange( Sorted[i], Sorted[k] );
    end;
  {}
  SortTime := GetTickCount - TickStart;
  TimeLabel3.Caption := IntToStr( SortTime );
  if( SortTime > 0 ) then
    EffLabel3.Caption := FloatToStr( SortNum / SortTime )
  else
    EffLabel3.Caption := 'Fehler';
  StatLabel3.Caption := IntToStr( SortNum );
  SortListUpdate;
  with List2Label do
    begin
      Caption := 'S&ortierte Liste (BubbleSort verwendet):';
      Update;
    end;
  EnableAll;
  QuiBtn.Default := true;
end;

procedure TMainForm.QuiBtnClick( Sender: TObject );
var i, j, k: SortInt;
begin
  DisableAll;
  with List2Label do
    begin
      Enabled := true;
      Caption := 'Liste wird mit QuickSort sortiert...';
      Update;
    end;
  StatLabel4.Caption := 'Wird sortiert';
  StatLabel4.Update;
  TimeLabel4.Caption := 'Wird sortiert';
  TimeLabel4.Update;
  EffLabel4.Caption := 'Wird sortiert';
  EffLabel4.Update;
  Sorted := Unsorted; { Sortierte Liste zurcksetzen }
  SortNum := 0;
  TickStart := GetTickCount;
  { QuickSort }
  k := High( SortInt ) div 2;
  while( k > 0 ) do
    begin
      for i := 1 to High( SortInt ) - k do
        begin
          j := i;
          while( (j >= 1) and (Sorted[j] > Sorted[j + k]) ) do
            begin
              SortChange( Sorted[j], Sorted[j + k] );
              if( j > k ) then
                 Dec( j, k )
              else
                j := 0;
            end;
        end;
        k := k div 2;
    end;
  {}
  SortTime := GetTickCount - TickStart;
  TimeLabel4.Caption := IntToStr( SortTime );
  if( SortTime > 0 ) then
    EffLabel4.Caption := FloatToStr( SortNum / SortTime )
  else
    EffLabel4.Caption := 'Fehler';
  StatLabel4.Caption := IntToStr( SortNum );
  SortListUpdate;
  with List2Label do
    begin
      Caption := 'S&ortierte Liste (QuickSort verwendet):';
      Update;
    end;
  EnableAll;
  btFuzzy.Default := true;
end;

procedure TMainForm.btFuzzyClick( Sender: TObject );
var i: SortInt;
begin
  DisableAll;
  with List2Label do
    begin
      Enabled := true;
      Caption := 'Liste wird mit FuzzySort sortiert...';
      Update;
    end;
  StatLabel5.Caption := 'Wird sortiert';
  StatLabel5.Update;
  TimeLabel5.Caption := 'Wird sortiert';
  TimeLabel5.Update;
  EffLabel5.Caption := 'Wird sortiert';
  EffLabel5.Update;
  Sorted := Unsorted; { Sortierte Liste zurcksetzen }
  SortNum := 0;
  TickStart := GetTickCount;
  { FuzzySort }
  i := 1;
  while ( i < High(SortInt) ) do
    begin
      if( Sorted[i] > Sorted[i + 1] ) Then
        begin
          SortChange( Sorted[i], Sorted[i + 1] );
          if( i > 1 ) then Dec( i );
        end
      else
        Inc( i );
    end;
  SortTime := GetTickCount - TickStart;
  TimeLabel5.Caption := IntToStr( SortTime );
  if( SortTime > 0 ) then
    EffLabel5.Caption := FloatToStr( SortNum / SortTime )
  else
    EffLabel5.Caption := 'Fehler';
  StatLabel5.Caption := IntToStr( SortNum );
  SortListUpdate;
  with List2Label do
    begin
      Caption := 'S&ortierte Liste (FuzzySort verwendet):';
      Update;
    end;
  EnableAll;
  StartBtn.Default := true;
end;

procedure TMainForm.LinHelpBtnClick( Sender: TObject );
begin
  with LinearForm do
    begin
      Position := poScreenCenter;
      ShowModal;
    end;
end;

procedure TMainForm.RipHelpBtnClick( Sender: TObject );
begin
  with RippleForm do
    begin
      Position := poScreenCenter;
      ShowModal;
    end;
end;

procedure TMainForm.BubHelpBtnClick( Sender: TObject );
begin
  with BubbleForm do
    begin
      Position := poScreenCenter;
      ShowModal;
    end;
end;

procedure TMainForm.QuiHelpBtnClick( Sender: TObject );
begin
  with QuickForm do
    begin
      Position := poScreenCenter;
      ShowModal;
    end;
end;

procedure TMainForm.btFuzzyHlpClick( Sender: TObject );
begin
  with fmFuzzy do
    begin
      Position := poScreenCenter;
      ShowModal;
    end;
end;

procedure TMainForm.ExitBtnClick( Sender: TObject );
begin
  Close;
end;

end.
